<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="pt"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>DomainUserDetailsService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Credenciamento</a> &gt; <a href="index.source.html" class="el_package">br.edu.unifacisa.lti.security</a> &gt; <span class="el_source">DomainUserDetailsService.java</span></div><h1>DomainUserDetailsService.java</h1><pre class="source lang-java linenums">package br.edu.unifacisa.lti.security;

import br.edu.unifacisa.lti.domain.User;
import br.edu.unifacisa.lti.repository.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Authenticate a user from the database.
 */
@Component(&quot;userDetailsService&quot;)
public class DomainUserDetailsService implements UserDetailsService {

<span class="fc" id="L24">    private final Logger log = LoggerFactory.getLogger(DomainUserDetailsService.class);</span>

    private final UserRepository userRepository;

<span class="fc" id="L28">    public DomainUserDetailsService(UserRepository userRepository) {</span>
<span class="fc" id="L29">        this.userRepository = userRepository;</span>
<span class="fc" id="L30">    }</span>

    @Override
    @Transactional
    public UserDetails loadUserByUsername(final String login) {
<span class="nc" id="L35">        log.debug(&quot;Authenticating {}&quot;, login);</span>
<span class="nc" id="L36">        String lowercaseLogin = login.toLowerCase(Locale.ENGLISH);</span>
<span class="nc" id="L37">        Optional&lt;User&gt; userFromDatabase = userRepository.findOneWithAuthoritiesByLogin(lowercaseLogin);</span>
<span class="nc" id="L38">        return userFromDatabase.map(user -&gt; {</span>
<span class="nc bnc" id="L39" title="All 2 branches missed.">            if (!user.getActivated()) {</span>
<span class="nc" id="L40">                throw new UserNotActivatedException(&quot;User &quot; + lowercaseLogin + &quot; was not activated&quot;);</span>
            }
<span class="nc" id="L42">            List&lt;GrantedAuthority&gt; grantedAuthorities = user.getAuthorities().stream()</span>
<span class="nc" id="L43">                    .map(authority -&gt; new SimpleGrantedAuthority(authority.getName()))</span>
<span class="nc" id="L44">                .collect(Collectors.toList());</span>
<span class="nc" id="L45">            return new org.springframework.security.core.userdetails.User(lowercaseLogin,</span>
<span class="nc" id="L46">                user.getPassword(),</span>
                grantedAuthorities);
<span class="nc" id="L48">        }).orElseThrow(() -&gt; new UsernameNotFoundException(&quot;User &quot; + lowercaseLogin + &quot; was not found in the &quot; +</span>
        &quot;database&quot;));
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.7.9.201702052155</span></div></body></html>